Subject: Re: bug#73813: 30.0.91; icomplete-mode keymap unusable in xterm for for/backward completions

From: Van Ly <[email-masked]>
Date: Thu, 17 Oct 2024 15:53:18 +0000

Robert Pluim <[email-masked]> writes:

>>>>>> On Thu, 17 Oct 2024 12:46:36 +0000, Van Ly <[email-masked]> said:

>
>     Van> I'd put icomplete-mode and icomplete-vertical-mode in the same category
>     Van> for binding interop.
>
> So that would be this:
>
> diff --git a/lisp/icomplete.el b/lisp/icomplete.el
> index 540ed2b5819..05914b24d2c 100644
> --- a/lisp/icomplete.el
> +++ b/lisp/icomplete.el
> @@ -178,6 +178,8 @@ icomplete-minibuffer-map
>    :doc "Keymap used by `icomplete-mode' in the minibuffer."
>    "C-M-i" #'icomplete-force-complete
>    "C-j"   #'icomplete-force-complete-and-exit
> +  "C-n"   #'icomplete-forward-completions
> +  "C-p"   #'icomplete-backward-completions
>    "C-."   #'icomplete-forward-completions
>    "C-,"   #'icomplete-backward-completions
>    "<remap> <minibuffer-complete-and-exit>" #'icomplete-ret)
>

Yes, please.

> I donʼt use icomplete or fido, so I have no real opinion to offer
> here, except that it would be nice to have bindings that work without
> having to modify xtermʼs configuration.

I agree.

>     >> Thatʼs possible, I guess `next-line' and `previous-line' arenʼt that
>     >> useful in that context.
>     >> 
>     >> But this is an area with a lot of history regarding the bindings, so
>     >> weʼd need to be careful. Perhaps we should consider '<left>' and
>     >> '<right>' instead, like `icomplete-fido'. Iʼm sure opinions will vary
>     >> :-)
>     >> 

In view-mode, are the self-insert bindings a bug or a feature?

>     Van> One more gotcha.  Inside a tmux session on xterm, emacsclient won't see
>     Van> C-, and C-. and maybe there are setting changes needed there.
>
> They work for me when using tmux as-is, but not when I use
> TERM=xterm-mono inside tmux
>

Why not enable the option to switch "emacsclient --color=no"?

-- 
vl